#ifndef TEXTURE_H_
#define TEXTURE_H_

#include <string>
#include <vector>

#include "image.h"

class Texture {
private:
	virtual void update() = 0;

protected:
	std::vector<Image> images;

public:
	std::string name;

	Texture();
	virtual ~Texture();

	virtual bool load(const char *fname);
	virtual bool load_cubemap(const char *fname);

	virtual bool is_cubemap() const;

	virtual void bind() = 0;
};

#endif // TEXTURE_H_